"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.izanamiReload = izanamiReload;
exports.registerFetch = registerFetch;
exports.register = register;
exports.unregister = unregister;

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var izanamiFetchs = {};
var izanamiListeners = {};

function izanamiReload(id) {
  var izanamiFetch = izanamiFetchs[id];

  if (izanamiFetch) {
    console.debug("Fetching for id ", id);
    izanamiFetch().then(function (r) {
      return r.json();
    }).then(function (data) {
      var listeners = izanamiListeners[id] || [];
      listeners.forEach(function (l) {
        try {
          l(data);
        } catch (err) {
          console.error(err);
        }
      });
    });
  }
}

function registerFetch(id, fetchMethod) {
  izanamiFetchs = _objectSpread({}, izanamiFetchs, _defineProperty({}, id, fetchMethod));
}

function register(id, callback) {
  var listeners = izanamiListeners[id] || [];
  var index = listeners.indexOf(callback);

  if (index > -1) {
    listeners.splice(index, 1);
  }

  listeners.push(callback);
  izanamiListeners = _objectSpread({}, izanamiListeners, _defineProperty({}, id, listeners));
}

function unregister(path, callback) {
  if (callback && path) {
    var listeners = izanamiListeners[path] || [];
    var index = listeners.indexOf(callback);

    if (index > -1) {
      listeners.splice(index, 1);
      izanamiListeners = _objectSpread({}, izanamiListeners, _defineProperty({}, path, listeners));
    }
  } else if (path) {
    delete izanamiListeners[path];
  }
}