"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExperimentsProvider = exports.Experiment = exports.Won = exports.Variant = void 0;

require("es6-shim");

require("whatwg-fetch");

var _esSymbol = _interopRequireDefault(require("es-symbol"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = require("prop-types");

var _deepEqual = _interopRequireDefault(require("deep-equal"));

var _deepmerge = _interopRequireDefault(require("deepmerge"));

var _get = _interopRequireDefault(require("lodash/get"));

var Api = _interopRequireWildcard(require("./api"));

var _globalThis = _interopRequireDefault(require("@ungap/global-this"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

if (!_globalThis.default.Symbol) {
  _globalThis.default.Symbol = _esSymbol.default;
}

var Variant =
/*#__PURE__*/
function (_Component) {
  _inherits(Variant, _Component);

  function Variant() {
    _classCallCheck(this, Variant);

    return _possibleConstructorReturn(this, _getPrototypeOf(Variant).apply(this, arguments));
  }

  _createClass(Variant, [{
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return Variant;
}(_react.Component);

exports.Variant = Variant;

_defineProperty(Variant, "propTypes", {
  id: _propTypes.string.isRequired
});

var Won =
/*#__PURE__*/
function (_Component2) {
  _inherits(Won, _Component2);

  function Won() {
    _classCallCheck(this, Won);

    return _possibleConstructorReturn(this, _getPrototypeOf(Won).apply(this, arguments));
  }

  _createClass(Won, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.notifyWon && !this.mounted) {
        this.mounted = true;
        var notifyWon = this.props.notifyWon;
        var url = notifyWon.indexOf('experiment=') > -1 ? notifyWon : notifyWon + '?experiment=' + this.props.path;
        fetch(url, {
          method: 'POST',
          credentials: 'include',
          headers: {
            'Content-Type': 'application/json'
          },
          body: JSON.stringify({
            experiment: this.props.path
          })
        }).then(function (r) {
          return r.json();
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return Won;
}(_react.Component);

exports.Won = Won;

_defineProperty(Won, "propTypes", {
  path: _propTypes.string.isRequired,
  notifyWon: _propTypes.string.isRequired,
  notifyWonHeaders: _propTypes.object.isRequired
});

var Experiment =
/*#__PURE__*/
function (_Component3) {
  _inherits(Experiment, _Component3);

  function Experiment() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Experiment);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Experiment)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      experiments: {},
      mergedExperiments: {}
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onExperimentsChanged", function (_ref) {
      var experiments = _ref.experiments;

      if (!(0, _deepEqual.default)(_this.state.experiments, experiments)) {
        _this.setState({
          experiments: experiments
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onContextChange", function (_ref2) {
      var __mergedExperiments = _ref2.__mergedExperiments,
          __id = _ref2.__id,
          __debug = _ref2.__debug;

      if (__id && _this.state.id !== __id) {
        if (__debug) console.log('[Experiments] Registering to api for ', __fetchFrom);

        _this.setState({
          id: __id,
          debug: __debug,
          mergedExperiments: __mergedExperiments
        });

        Api.register(__id, _this.onExperimentsChanged);
      } else {
        _this.setState({
          debug: __debug,
          mergedExperiments: __mergedExperiments
        });
      }
    });

    return _this;
  }

  _createClass(Experiment, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.context.__subscribeToExperimentContext(this.onContextChange);

      if (this.props.notifyDisplay && !this.mounted) {
        this.mounted = true;
        var notifyDisplay = this.props.notifyDisplay;
        var url = notifyDisplay.indexOf('experiment=') > -1 ? notifyDisplay : notifyDisplay + '?experiment=' + this.props.path;
        fetch(url, {
          method: 'POST',
          credentials: 'include',
          headers: {
            'Content-Type': 'application/json'
          },
          body: JSON.stringify({
            experiment: this.props.path
          })
        }).then(function (r) {
          return r.json();
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
      var fetchFrom = this.state.fetchFrom;

      if (fetchFrom) {
        Api.unregister(fetchFrom, this.onExperimentsChanged);
      }

      this.context.__unsubscribeToExperimentContext(this.onContextChange);
    }
  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      var path = this.props.path.replace(/:/g, '.');
      var experiments = (0, _deepmerge.default)(this.state.mergedExperiments, this.state.experiments);
      var experiment = (0, _get.default)(experiments, path) || {
        variant: null
      };
      var value = experiment.variant || this.props.default;
      var childrenArray = Array.isArray(children) ? children : [children];
      var variantChildren = childrenArray.filter(function (c) {
        return c.type === Variant;
      }).filter(function (c) {
        return c.props.id === value;
      });
      var debug = !!this.state.debug || this.props.debug;

      if (variantChildren.length === 0) {
        if (debug) console.log("[Experiments] experiment '".concat(path, "' has no valid Variant ").concat(value, ". Please provide one."));
        return null;
      } else {
        var variant = variantChildren[0] || null;
        if (debug) console.log("[Experiments] experiment '".concat(path, "' (").concat(JSON.stringify(experiment), ") has variant ").concat(value));

        if (variant && debug) {
          var color = '#' + (~~(Math.random() * (1 << 24))).toString(16);
          return _react.default.createElement("div", {
            className: "izanami-experiment",
            title: "Experiment ".concat(path, ":\xA0variant is ").concat(value),
            style: {
              position: 'relative',
              outline: '1px solid ' + color
            }
          }, _react.default.createElement("span", {
            style: {
              padding: 2,
              opacity: '0.9',
              fontFamily: 'Arial',
              color: 'white',
              border: '1px solid black',
              borderRadius: '5px',
              backgroundColor: color,
              position: 'absolute',
              top: -17,
              left: -1,
              zIndex: 100000,
              boxShadow: '0 4px 8px 0 rgba(0, 0, 0, 0.3), 0 6px 20px 0 rgba(0, 0, 0, 0.19)'
            }
          }, "Experiment ", _react.default.createElement("span", {
            style: {
              fontWeight: 'bold'
            }
          }, path), ":\xA0variant is ", _react.default.createElement("span", {
            style: {
              fontWeight: 'bold'
            }
          }, value)), variant);
        }

        return variant;
      }
    }
  }]);

  return Experiment;
}(_react.Component);

exports.Experiment = Experiment;

_defineProperty(Experiment, "contextTypes", {
  __subscribeToExperimentContext: _propTypes.func,
  __unsubscribeToExperimentContext: _propTypes.func
});

_defineProperty(Experiment, "propTypes", {
  path: _propTypes.string.isRequired,
  default: _propTypes.string,
  debug: _propTypes.bool,
  notifyDisplay: _propTypes.string,
  notifyDisplayHeaders: _propTypes.object
});

_defineProperty(Experiment, "defaultProps", {
  debug: false,
  notifyDisplayHeaders: {}
});

var ExperimentsProvider =
/*#__PURE__*/
function (_Component4) {
  _inherits(ExperimentsProvider, _Component4);

  function ExperimentsProvider() {
    var _getPrototypeOf3;

    var _this2;

    _classCallCheck(this, ExperimentsProvider);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _possibleConstructorReturn(this, (_getPrototypeOf3 = _getPrototypeOf(ExperimentsProvider)).call.apply(_getPrototypeOf3, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this2)), "callbacks", []);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this2)), "state", {
      __experiments: _this2.props.experiments,
      __fallback: _this2.props.fallback,
      __mergedExperiments: (0, _deepmerge.default)(_this2.props.fallback, _this2.props.experiments),
      __id: _this2.props.id,
      __debug: _this2.props.debug
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this2)), "registerCb", function (callback) {
      var index = _this2.callbacks.indexOf(callback);

      if (index === -1) {
        _this2.callbacks.push(callback);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this2)), "unregisterCb", function (callback) {
      var index = _this2.callbacks.indexOf(callback);

      if (index > -1) {
        _this2.callbacks.splice(index, 1);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this2)), "publish", function () {
      _this2.callbacks.forEach(function (cb) {
        cb(_objectSpread({}, _this2.state));
      });
    });

    return _this2;
  }

  _createClass(ExperimentsProvider, [{
    key: "getChildContext",
    value: function getChildContext() {
      var _this3 = this;

      return {
        __subscribeToExperimentContext: function __subscribeToExperimentContext(cb) {
          if (cb) {
            cb(_objectSpread({}, _this3.state));

            _this3.registerCb(cb);
          }
        },
        __unsubscribeToExperimentContext: function __unsubscribeToExperimentContext(cb) {
          if (cb) {
            _this3.unregisterCb(cb);
          }
        }
      };
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _deepEqual.default)(nextProps.experiments, this.props.experiments)) {
        this.setState({
          __experiments: nextProps.experiments,
          __mergedExperiments: (0, _deepmerge.default)(this.state.__fallback, nextProps.experiments)
        }, this.publish);
      }

      if (!(0, _deepEqual.default)(nextProps.fallback, this.props.fallback)) {
        this.setState({
          __fallback: nextProps.fallback,
          __mergedExperiments: (0, _deepmerge.default)(nextProps.fallback, this.state.__experiments)
        }, this.publish);
      }

      if (nextProps.debug !== this.props.debug) {
        this.setState({
          __debug: nextProps.debug
        }, this.publish);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children || null;
    }
  }]);

  return ExperimentsProvider;
}(_react.Component);

exports.ExperimentsProvider = ExperimentsProvider;

_defineProperty(ExperimentsProvider, "childContextTypes", {
  __subscribeToExperimentContext: _propTypes.func,
  __unsubscribeToExperimentContext: _propTypes.func
});

_defineProperty(ExperimentsProvider, "propTypes", {
  experiments: _propTypes.object.isRequired,
  fallback: _propTypes.object,
  id: _propTypes.string,
  debug: _propTypes.bool
});

_defineProperty(ExperimentsProvider, "defaultProps", {
  fallback: {}
});